;Radius 86 
;Copyright 2000 Ross Palmer
;Cybeross@aol.com
;You are free to take examples and borrow from my code,
;although it is not very well comented
;PLEASE do not rip off the whole code. You may make changes
;if you like, but do not distribute the modified version.
;If you make changes for the better such as optimization 
;and the like, e-mail it to me and I will consider releasing
;it with your changes.
;I hope this is useful for those interested in math functions. :)

#include "ti86asm.inc"

.org _asm_exec_ram

Start:
	ld hl,FPNum1
	call 	$42D7
	call	$4263
	call    $4A7E
    call    $4A86
    call    $4A95
	ld hl,title
	ld de,$c324
	ld bc,51
	ldir
	res 4,(iy+9)
    ld      a,0Dh
    ld      ($D623),a
    call    $5714
	call	_chkON
	jr nz,Start			;if they hit on, get string again
solve:
	call	$4AB1
	call	_ckop1pos
	jp nz,error
	ld de,space
	call _movfroop1
solve2:
	call	_op1toop5
	call	_FPSQUARE ;x^2
	rst 08h ;x to op2
	call	_op5toop1
	rst 28h ;x*y to x	same as call _FPMULT
	call	_op6toop2 
	rst 28h
	ld de,space1
	call	_movfroop1
	call	$4A95
	call	$4A82
	call disp_screen	
	ld a,8
	ld hl,answer
	call	got_size2
	ld a,14
	call	_dispop1a 
	ld hl,space
	rst 20h
	call	_FPSQUARE
	rst 08h
	ld hl,FPNum2
	rst 20h
	rst 28h
	ld a,20
	ld hl,ans
	call	got_size2
	ld a,26
	call	_dispop1a 
	ld de,space2
	call	_movfroop1
	ld hl,space1
	rst 20h
	call	_TIMESPT5
	ld a,32
	ld hl,ans2
	call	got_size2
	ld a,38
	call	_dispop1a
	ld hl,space
	rst 20h
	call	_FPSQUARE
	rst 08h
	ld hl,FPNum3
	rst 20h
	rst 28h
	ld a,44
	ld hl,ans3
	call	got_size2
	ld a,50
	call	_dispop1a
	ld a,56
	ld hl,more
	call	got_size2
loop:
	call 	$4068
	cp		K_MORE
	jp		z,More
	cp		K_EXIT
	jp		z,Exit
	jr		loop
	
Exit:
	res   4,(iy+$09)
	call	$4A95
	call	$4A82
	ret

_dispop1a:
	push	af
	ld      a,48
    call    _formReal
    ld      hl,_OP3
	pop		af
	ld d,120
    jp    vputs

More:
	call	$4A95
	call	$4A82
	call disp_screen
	ld hl,space2
	rst 20h
	call	_TIMESPT5
	call	_TIMESPT5
	ld a,20
	ld hl,ar
	call	got_size2
	ld a,26
	call	_dispop1a 
	ld a,56
	ld hl,more
	call	got_size2
	ld a,32
	ld hl,circ
	call	got_size2
	ld hl,FPNum2
	rst 20h
	call	_TIMESPT5
	rst 08h
	ld hl,space
	rst 20h
	rst 28h
	ld a,38
	call	_dispop1a
	ld hl,FPNum1
	call 	$42D7
	call	$4263
	ld hl,space
	rst 20h 
loop2:
	call 	$4068
	cp		K_MORE
	jp		z,solve2
	cp		K_EXIT
	jp		z,Exit
	jr		loop2


error:
	ld hl,$0003
	ld (_curRow),hl
	ld hl,err
	set 3,(iy+$05)
	call _puts
	res 3,(iy+$05)
	call	_pause
	jp	Start

disp_screen:
	set 3,(iy+$05)
	ld hl,answers
	call	$4A37
	ld hl,$0102
	ld (_penCol),hl
	ld a,'R'
	call _vputmap
	ld hl,$0179
	ld (_penCol),hl
	ld a,'P'
	call _vputmap
	res 3,(iy+$05)
	ret

title:
	.db "Radius Solver    v0.9"
	.db "   -By Ross Palmer   "
enter:
	.db "Radius=?",0

err:
	.db " Can't be negative!! ",0
circ:
	.db "Circumference of circle:",0
ar:
	.db "Area of circle:",0
answer:
	.db "Volume of sphere:",0
ans:
	.db "Area of sphere:",0
more:
	.db "Press MORE for more answers-------",0
ans3:
	.db "Area of hemisphere:",0
ans2:
	.db "Volume of hemisphere:",0
answers:
	.db "       Answers       "

FPNum1:		;(4/3)pi
	.db $00,$00,$FC,$13,$33,$33,$33,$33,$33,$33
FPNum2:		;4pi
	.db $00,$00,$FC,$40,$00,$00,$00,$00,$00,$00
FPNum3:		;3pi
	.db $00,$00,$FC,$30,$00,$00,$00,$00,$00,$00
space:
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0
space1:
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0
space2:
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0

space6:
	.db 0,0,0,0,0,0,0,0,0,0,0

vputs:
	push hl
	push de
	ld (_penRow),a			;set pen row
	ld e,0				;length
get_size:
	ld a,(hl)				;get next byte
	or a					;check if a=0
	jr z,got_size			;finished getting size
	push hl
	push de
	call _get_vchar			;hl->size of char
	pop de
	ld a,(hl)				;get size
	add a,e				;add to cumulative length
	ld e,a				;save
	pop hl
	inc hl					;next byte
	jr get_size
got_size:					;divide by 2
	pop af				;center column
	sub e				;a=center column
	ld (_penCol),a
	pop hl				;retrieve start of text
	call _vputs
	ld a,$C4
	jp _vputmap
				;print the text

got_size2:
	ld (_penRow),a
	ld a,1
	ld (_penCol),a
	jp _vputs	
				;print the text



.end
